import pandas as pd
import numpy as np
from util import read_usertask, read_userinfo, load_answers, obtain_user_characteristic
from util import calc_system_advice, calc_numeracy, calc_TiA_scale, calc_ATI_scale, TiA_subscales, calc_reliance_measures, calc_reliance_measures_2
from util import task_list_1, task_list_2, task_list_3
from scipy.stats import mannwhitneyu
user_familiarity_dict, user_trust_dict, user_confidence_dict = obtain_user_characteristic()




def compare_characteristc(analogy_characteristic_dict, var_name="Familiarity"):
	tp_data = analogy_characteristic_dict[var_name]
	print(var_name)
	for analogy_domain in ["train", "weather", "vaccine"]:
		data_1 = tp_data[analogy_domain]
		for analogy_domain_ in ["train", "weather", "vaccine"]:
			if analogy_domain_ == analogy_domain:
				continue
			data_2 = tp_data[analogy_domain_]
			statistic, pvalue = mannwhitneyu(data_1, data_2, alternative='greater')
			print(f"Alternative {analogy_domain} > {analogy_domain_},", "pvalue %.4f"%pvalue, "statistic %.4f"%statistic)
	print("-" * 34)


analogy_characteristic_dict = {}
analogy_characteristic_dict["Familiarity"] = {}
analogy_characteristic_dict["Trust"] = {}
analogy_characteristic_dict["Confidence"] = {}

print("-" * 34)
for analogy_domain in ["train", "weather", "vaccine"]:
	print(analogy_domain)
	familiarity_list, trust_list, confidence_list = [], [], []
	for user in user_familiarity_dict:
		familiarity_list.append(user_familiarity_dict[user][analogy_domain])
		trust_list.append(user_trust_dict[user][analogy_domain])
		confidence_list.append(user_confidence_dict[user][analogy_domain])
	print("Familiarity: mean {:.2f}, SD {:.2f}".format(np.mean(familiarity_list), np.std(familiarity_list, ddof=1)))
	print("Trust: mean {:.2f}, SD {:.2f}".format(np.mean(trust_list), np.std(trust_list, ddof=1)))
	print("Confidence: mean {:.2f}, SD {:.2f}".format(np.mean(confidence_list), np.std(confidence_list, ddof=1)))
	analogy_characteristic_dict["Familiarity"][analogy_domain] = familiarity_list
	analogy_characteristic_dict["Trust"][analogy_domain] = trust_list
	analogy_characteristic_dict["Confidence"][analogy_domain] = confidence_list
	print("-" * 34)
compare_characteristc(analogy_characteristic_dict, "Familiarity")
compare_characteristc(analogy_characteristic_dict, "Trust")
compare_characteristc(analogy_characteristic_dict, "Confidence")

# statistic, pvalue = stats.mannwhitneyu(data_list_2, data_list_3, alternative='greater')
# print("Alternative accuracy > analogy,", "pvalue %.4f"%pvalue, "statistic %.4f"%statistic)