import seaborn as sns
import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
from util import read_usertask, read_userinfo, load_answers, obtain_user_characteristic
from util import calc_system_advice, calc_numeracy, calc_TiA_scale, calc_ATI_scale, TiA_subscales, calc_reliance_measures, calc_reliance_measures_2
from util import task_list_1, task_list_2, task_list_3

def draw_bar_plot(data_dict):
	df = pd.DataFrame(data_dict, dtype=float)
	sns.set_theme(style="whitegrid")
	sns.set(font="Arial")
	# ax = sns.boxplot(data=df)
	ax = sns.barplot(x="Dimension", y="Value", hue="analogy_domain", data=df)
	ax.tick_params(labelsize=18)
	ax.set_xlabel("Dimension", fontsize = 24)
	ax.set_ylabel("Value", fontsize = 24)
	plt.setp(ax.get_legend().get_texts(), fontsize='16') # for legend text
	plt.setp(ax.get_legend().get_title(), fontsize='16') # for legend title
	plt.margins(0.015, tight=True)
	# ax.legend(labels=["Yes","No"], fontsize = 18)
	plt.show()

user_familiarity_dict, user_trust_dict, user_confidence_dict = obtain_user_characteristic()
data_long_format = {}
data_long_format["Dimension"] = []
data_long_format["Value"] = []
data_long_format["analogy_domain"] = []
for user in user_familiarity_dict:
	for analogy_domain in ["train", "weather", "vaccine"]:
		data_long_format["Dimension"].append("Familiarity")
		data_long_format["Value"].append(user_familiarity_dict[user][analogy_domain])
		data_long_format["analogy_domain"].append(analogy_domain)
		data_long_format["Dimension"].append("Trust")
		data_long_format["Value"].append(user_trust_dict[user][analogy_domain])
		data_long_format["analogy_domain"].append(analogy_domain)
		data_long_format["Dimension"].append("Confidence")
		data_long_format["Value"].append(user_confidence_dict[user][analogy_domain])
		data_long_format["analogy_domain"].append(analogy_domain)
draw_bar_plot(data_long_format)