import pandas as pd
import numpy as np
# import matplotlib.pyplot as plt
# import seaborn as sns
import sklearn as skl

import warnings
warnings.filterwarnings('ignore')
# data header:
# Loan_ID,Gender,Married,Dependents,Education,Self_Employed,
# ApplicantIncome,CoapplicantIncome,LoanAmount,Loan_Amount_Term,
# Credit_History,Property_Area,Loan_Status

# reserved_features = ['Loan_ID', 'Education', 'ApplicantIncome', 'CoapplicantIncome', 
# 'LoanAmount', 'Loan_Amount_Term', 'Credit_History', 'Property_Area' ,'Loan_Status']

# reference code from https://www.kaggle.com/anoshpa/loan-prediction

data_file = '/Users/hegaole/PhD/kappa_group/Projects/ANIE/loan_data/kaggle_loan_prediction_data/train_u6lujuX_CVtuZ9i.csv'
# loan_data = pd.read_csv(data_file, usecols=reserved_features)
df = pd.read_csv(data_file)

df["Gender"] = df["Gender"].fillna(df["Gender"].mode()[0])
df["Married"] = df["Married"].fillna(df["Married"].mode()[0])
df["Dependents"] = df["Dependents"].fillna(df["Dependents"].mode()[0])
df["Self_Employed"] = df["Self_Employed"].fillna(df["Self_Employed"].mode()[0])
# I have replaced missing values in Credit_History column with most frequent value - 1.0
df["Credit_History"] = df["Credit_History"].fillna(1.0)

# drop any row which contain nan for 'LoanAmount' or 'Loan_Amount_Term'
loan_data = df.dropna(axis=0, how='any')
# print(loan_data)
# print(loan_data.describe())
# print(loan_data.iloc[:3, :])
# loan_data.to_csv('/Users/hegaole/PhD/kappa_group/Projects/ANIE/loan_data/kaggle_loan_prediction_data/train_processed.csv', index=False)

# '''
# Use total income
# loan_data["TotalIncome"] = loan_data["ApplicantIncome"] + loan_data["CoapplicantIncome"]
# cols=["ApplicantIncome","CoapplicantIncome"] # ,"Loan_ID"
# loan_data.drop(cols,axis=1,inplace=True)
# print(loan_data.head())

# use log of total income and loanAmount
# loan_data["TotalIncome"] = np.log(loan_data["TotalIncome"])
# loan_data["LoanAmount"] = np.log(loan_data["LoanAmount"])
loan_data["ApplicantIncome"] = np.log(loan_data["ApplicantIncome"]+1)
loan_data["CoapplicantIncome"] = np.log(loan_data["CoapplicantIncome"]+1)
loan_data["LoanAmount"] = np.log(loan_data["LoanAmount"]+1)
# '''


# transform category attributes to value
from sklearn.preprocessing import LabelEncoder
cols = ["Gender","Married","Education","Self_Employed","Property_Area","Loan_Status","Dependents"]
le = LabelEncoder()
for col in cols:
    loan_data[col] = le.fit_transform(loan_data[col])

from sklearn.model_selection import train_test_split
IDs = loan_data["Loan_ID"]
X = loan_data.drop(["Loan_Status", "Loan_ID"],axis=1)
Y = loan_data["Loan_Status"]
# print(type(IDs))
# print(type(X))
x_train,x_test,y_train,y_test = train_test_split(X,Y,test_size=0.2, random_state=42)
# print(type(x_train))
# print(x_train.iloc[0])

# from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import cross_val_score
# model = LogisticRegression()
# from sklearn.ensemble import RandomForestClassifier
# model=RandomForestClassifier()
from sklearn.linear_model import LinearRegression
model = LinearRegression()
# from sklearn.tree import DecisionTreeClassifier
# model=DecisionTreeClassifier()
# model.fit(x_train,y_train)
model.fit(X,Y)
# feature_weight = model.coef_[0]
# print(model.coef_)
f = open("/Users/hegaole/PhD/kappa_group/Projects/ANIE/loan_data/lr_selection/weight_ori_log.txt", "w")
for val in model.coef_:
    # print("%.4f"%(val))
    f.write("%.4f\n"%(val))
f.close()
model_prediction = model.predict(X)
y_list = Y.tolist()
right_case = 0
wrong_case = 0
zero_case = 0
one_case = 0
positive_decision_list = []
negative_decision_list = []
for loan_id, score, label in zip(IDs, model_prediction, y_list):
    if label == 1.0:
        positive_decision_list.append((loan_id, score))
        one_case += 1
    else:
        negative_decision_list.append((loan_id, score))
        zero_case += 1
    if abs(score - label) < 0.5:
        right_case += 1
    else:
        wrong_case += 1
print("Right prediction of model is {}, wrong is {}".format(right_case, wrong_case))
print("One case of data is {}, zero is {}".format(one_case, zero_case))
sorted_postive_cases = sorted(positive_decision_list, key=lambda x:x[1], reverse=True)
f = open("/Users/hegaole/PhD/kappa_group/Projects/ANIE/loan_data/lr_selection/lr_reg_pos_ori_log.txt", "w")
for loan_id, score in sorted_postive_cases:
    f.write("%s\t%.4f\n"%(loan_id, score))
f.close()
# print(sorted_postive_cases)
sorted_negative_cases = sorted(negative_decision_list, key=lambda x:x[1])
f = open("/Users/hegaole/PhD/kappa_group/Projects/ANIE/loan_data/lr_selection/lr_reg_neg_ori_log.txt", "w")
for loan_id, score in sorted_negative_cases:
    f.write("%s\t%.4f\n"%(loan_id, score))
f.close()
# print(sorted_negative_cases)
# print(right_case, wrong_case)
# print(Y)
# print("Accuracy of model is",model.score(x_test,y_test)*100)
# score = cross_val_score(model,X,Y,cv=5)
# print("Cross Validation is",np.mean(score)*100)





