import numpy as np
import pandas as pd
import os


def read_age_sex():
	filename = os.path.join("../anonymous_data", "prolific_demographic.csv")
	usecols = ['age', 'Sex']
	df = pd.read_csv(filename, usecols=usecols)
	user_status_list = df.values.tolist()
	age_list = []
	sex_list = []
	for age, sex in user_status_list:
		if age is None or sex is None:
			print(age, sex)
		age_list.append(age)
		sex_list.append(sex)
	return age_list, sex_list

# this file could report statistics in Sec. 4.4
if __name__ == "__main__":
	age_list, sex_list = read_age_sex()
	age_value_list = []
	for i, age in enumerate(age_list):
		if age >= 18 and age <= 100:
			age_value_list.append(age)
		else:
			print(i, age)
	print(np.mean(age_value_list), min(age_value_list), max(age_value_list))
	print("Age mean:{:.2f} std:{:.2f}".format(np.mean(age_value_list), np.std(age_value_list, ddof=1)))
	sex_dict = {}
	for i, sex in enumerate(sex_list):
		if sex not in sex_dict:
			sex_dict[sex] = 0
		sex_dict[sex] += 1
	print(sex_dict)
	print("Male: {:.3f}, Female: {:.3f}, Other: {:.3f}".format(sex_dict["Male"] / 281.0, sex_dict["Female"] / 281.0, (281 - sex_dict["Male"] - sex_dict["Female"])/ 281.0 ))