import numpy as np
import pandas as pd
import os


def load_labels():
	reserved_features = ['sentiment_group']
	answer_file = "../anonymous_data/PostQ_analogy_labeled.csv"
	answer_df = pd.read_csv(answer_file, usecols=reserved_features)
	answer_list = answer_df.values.tolist()
	group_ct = {}
	for group_str in answer_list:
		tp_str = group_str[0]
		if tp_str not in group_ct:
			group_ct[tp_str] = 0
		group_ct[tp_str] += 1
	print(group_ct)
	group_ct_list = [(group, group_ct[group]) for group in group_ct]
	group_ct_list.sort(key=lambda x:x[1], reverse=True)
	print("Negative Opinion")
	negative_opinion = 0
	for group, ct in group_ct_list:
		if "useless" in group or "negative" in group:
			print(group, ct)
			negative_opinion += ct
	print("{} participants hold negative opinion".format(negative_opinion))
	print('-' * 17)
	positive_opinion = 0
	print("Positive Opinion")
	for group, ct in group_ct_list:
		if "positive" in group:
			print(group, ct)
			positive_opinion += ct
	print("{} participants hold positive opinion".format(positive_opinion))
	print('-' * 17)
	print("Other Opinion")
	for group, ct in group_ct_list:
		if "useless" not in group and "negative" not in group and 'positive' not in group:
			print(group, ct)


load_labels()