import numpy as np
import pandas as pd
import os


from util import filter_invalid_users, read_usertask, read_userinfo, load_answers
from util import User_groups, Analogy_types, task_ID_list, case_dict, trust_dict, reverse_answer


def calc_switching_all(usertask_dict, system_advice_dict, answer_dict, user_group_dict, user_analogy_dict):
	switching_cases = {}
	accuracy_dict = {}
	for group in User_groups:
		switching_cases = []
		accuracy_dict = []
	case_ct = {}
	for user in usertask_dict:
		user_group = user_group_dict[user]
		analogy_type = user_analogy_dict[user]
		user_trust_list = []
		tp_correct = 0
		for task_id in task_ID_list:
			first_choice = usertask_dict[user][(task_id, "base")]
			second_choice = usertask_dict[user][(task_id, user_group)]
			system_advice = system_advice_dict[user][task_id]
			correct_answer = answer_dict[task_id]
			case = case_dict[(first_choice, second_choice, system_advice)]
			if second_choice == correct_answer:
				tp_correct += 1
			# if case in [3, 4, 5, 6]:
			# 	participants switch choices
			# trust_pattern = trust_dict[case]
			user_trust_list.append(case)
			if case not in case_ct:
				case_ct[case] = 0
			case_ct[case] += 1
		switching_cases.append(user_trust_list)
	case_dict_rev = {v:k for k,v in case_dict.items()}
	total = 0
	for case in range(1, 9):
		print(case_dict_rev[case], "{:.3f}".format(case_ct[case] / 2810))
		total += case_ct[case]

def calc_system_advice(userinfo_dict, answer_dict):
	system_advice_dict = {}
	user_group_dict = {}
	user_analogy_dict = {}
	for user in userinfo_dict:
		__, task_order_str, reverse_flag_str, user_group, analogy_type = userinfo_dict[user]
		user_group_dict[user] = user_group
		user_analogy_dict[user] = analogy_type
		system_advice_dict[user] = {}
		taks_order_list = task_order_str.split("|")
		reverse_flag_list = reverse_flag_str.split("|")
		for i, task_id in enumerate(taks_order_list):
			correct_answer = answer_dict[task_id]
			reverse_flag = eval(reverse_flag_list[i])
			if reverse_flag:
				system_advice_dict[user][task_id] = reverse_answer(correct_answer)
			else:
				system_advice_dict[user][task_id] = correct_answer
	return system_advice_dict, user_group_dict, user_analogy_dict

# code to report table 1
if __name__ == "__main__":
	reserved_users = filter_invalid_users(exclude_round1=False)
	usertask_dict, user_attention_check_correct = read_usertask(reserved_users)
	userinfo_dict = read_userinfo(reserved_users)
	answer_dict = load_answers()
	system_advice_dict, user_group_dict, user_analogy_dict = calc_system_advice(userinfo_dict, answer_dict)
	calc_switching_all(usertask_dict, system_advice_dict, answer_dict, user_group_dict, user_analogy_dict)