import pandas as pd
import numpy as np
import sys

# data_file = './first/usertask.csv'
data_file = sys.argv[1]
df = pd.read_csv(data_file, usecols=['user_id','task_id', 'answer_type', 'choice'])
df = df.drop(df[df['user_id'].map(len) < 24].index)
# df = df.drop(df[df['user_id'] == '611377fd09174366ceb0193b'].index)
df = df.drop(df[df['user_id'] == '6112352c836239c7d189f38e'].index)
# df = df.drop(df[df['user_id'] != '6115022053df5b4d387d150d'].index)
user_task_list = df.values.tolist()


reserved_features = ['Loan_ID', 'Loan_Status', 'Sample_Category']
answer_file = "../loan_data_selection/selected_samples.csv"
answer_df = pd.read_csv(answer_file, usecols=reserved_features)
answer_list = answer_df.values.tolist()

def deal_answer_list(answer_list):
	answer_dict = {}
	for Loan_ID, Loan_Status, Sample_Category in answer_list:
		tp_answer = "accept" if Loan_Status == "Y" else "reject"
		answer_dict[Loan_ID] = tp_answer
	return answer_dict

def deal_task_list(user_task_list):
	user_task_dict = {}
	user_attention_check_correct = {}
	for user_id, task_id, answer_type, choice in user_task_list:
		if user_id not in user_task_dict:
			user_task_dict[user_id] = {}
		if user_id not in user_attention_check_correct:
			user_attention_check_correct[user_id] = 0
		if answer_type == "attention":
			if task_id == "LP001518" and choice == "yes":
				user_attention_check_correct[user_id] += 1
			if task_id == "LP002723" and choice == "no":
				user_attention_check_correct[user_id] += 1
		else:
			user_task_dict[user_id][task_id] = choice
	return user_task_dict, user_attention_check_correct

answer_dict = deal_answer_list(answer_list)
# print(answer_dict)
user_task_dict, user_attention_check_correct = deal_task_list(user_task_list)
acc_list = []
easy_tasks = ['LP001030', 'LP001849']
hard_tasks = ['LP002068', 'LP002840']
easy_list = []
hard_list = []
task_acc = {}
valid_user_number = 0
user_correct_list = []
for user_id in user_task_dict:
	if user_attention_check_correct[user_id] < 2:
		# print(len(user_task_dict[user_id]))
		# print("User {} didn't pass both attention checks.".format(user_id))
		continue
	# assert len(user_task_dict[user_id]) == 10
	valid_user_number += 1
	tp_correct = 0
	for task_id in user_task_dict[user_id]:
		if task_id not in task_acc:
			task_acc[task_id] = 0
		if user_task_dict[user_id][task_id] == answer_dict[task_id]:
			tp_correct += 1
			task_acc[task_id] += 1
			if task_id in easy_tasks:
				easy_list.append(1.0)
			elif task_id in hard_tasks:
				hard_list.append(1.0)
		else:
			if task_id in easy_tasks:
				easy_list.append(0.0)
			elif task_id in hard_tasks:
				hard_list.append(0.0)
	print("User {} correctly answered {} tasks.".format(user_id, tp_correct))
	user_correct_list.append((user_id, tp_correct))
	acc_list.append(tp_correct / 10.0)
# To help provide bonus
# user_correct_list.sort(key=lambda x:x[1], reverse=True)
# for user_id, corr in user_correct_list:
# 	print(user_id, corr)
print("Average accuracy: {:.2f}".format(np.mean(acc_list)))
print(np.mean(acc_list), np.std(acc_list, ddof=1))
print("For easy tasks")
# easy_list = []
# for task in easy_tasks:
# 	easy_list.append(task_acc[task] / valid_user_number)
print(easy_list)
print(np.mean(easy_list), np.std(easy_list, ddof=1))
print("For hard tasks")
# hard_list = []
# for task in hard_tasks:
# 	hard_list.append(task_acc[task] / valid_user_number)
print(hard_list)
print(np.mean(hard_list), np.std(hard_list, ddof=1))
for task_id in task_acc:
	print("Task {}, {} among {} participants made correct decision, acc: {:.3f}.".format(task_id, task_acc[task_id], valid_user_number, task_acc[task_id] / valid_user_number))



